GammalLib - Change request #1052

GammalL.ib local sphinx docs sometimes load slowly because they fetch Google fonts and Mathjax
online

01/04/2014 12:35 PM - Deil Christoph

Status: New Start date: 01/04/2014
Priority: Low Due date: 01/31/2014
Assigned To: Deil Christoph % Done: 0%
Category: Estimated time: 0.00 hour
Target version:

Description
I'm currently on a sluggish internet connection and noticed that sometimes loading a local GammalLib Sphinx docs page takes a few
seconds.

The reason is that Google fonts and Mathjax files are loaded from the internet (see attached screenshot).

This should be changed so that either all required files are bundled in the GammalLib repo or there is an option to fetch them once
e.g. when ““make sphinx™ executes,
so that browsing the local docs doesn't hit the network.

History

#1 - 01/05/2014 11:24 PM - Knodlseder Jiirgen

Any clues how to package the needed things in GammaLib?

#2 - 01/05/2014 11:33 PM - Deil Christoph
- Due date set to 01/31/2014
- Assigned To set to Deil Christoph

- Target version set to 2nd coding sprint

No clue. I'll have to investigate.

#3 - 01/07/2014 05:11 PM - Knodlseder Jiirgen

- Tracker changed from Bug to Change request

#4 - 01/14/2014 11:20 AM - Deil Christoph
In principle using a local copy of Mathjax with Sphinx and Doxygen is easy:
® Download a local copy of Mathjax: http://www.mathjax.org/download/

e Tell Sphinx to use the local copy of Mathjax: http:/sphinx-doc.org/latest/ext/math.html#confval-mathjax_path
e Tell Doxygen to use the local copy of Mathjax: http://www.stack.nl/~dimitri/doxygen/manual/config.html#cfg_mathjax_relpath

In detail I'm not sure how best to implement this:

¢ How should the download be done? Add a separate make download-mathjax target? Use curl or wget or Python to do the download?

¢ When should the download be done? Automatically with make doc because fast local docs is what most developers want?

e For the online docs and users that don't want to download Mathjax, the Sphinx and Doxygen docs still need to point to the Mathjax version on
the web, so the use of local Mathjax needs to be optional somehow.

IPython has a script to download Mathjax that we could maybe adapt if you want to use Python for the download:
http://ipython.org/ipython-doc/stable/install/install. html#mathjax
https://github.com/ipython/ipython/blob/master/IPython/external/mathjax.py

Shark adds some JavaScript lines in the Sphinx and Doxygen header to optionally load the local or online version of Mathjax:
http://image.diku.dk/shark/sphinx_pages/build/html/rest_sources/tutorials/for_developers/managing_the_documentation.html#mathjax

https://github.com/chrisvana/shark_copy/blob/master/doc/doxygen_pages/templates/header.html
https://github.com/chrisvana/shark_copy/blob/master/doc/sphinx_pages/templates/layout.html#L6

I think this is a nice solution, although | think the default should be to use a local version if available so that it's fast and no web request is made if the
local version is available.

I won't have time to implement and test this before the coding sprint, if someone else wants to do it, please go ahead.

#5 - 01/16/2014 03:36 PM - Knodlseder Jiirgen

The only problem | see with the download during making is that you'll miss the download in case that the machine is not connected to internet during
installation. So ideally, the stuff should be shipped with GammalLib.

We may not do this for developers (they could use indeed a specific target to download the fonts), but when building the release packages we should
just add the fonts to the package before building the tarball.

On the other hand, | see that MathJax-2.3 comprises 32.9 MB of data, which | would prefer not having within gammalib (this would make the tarball
very large). So we may use the download during make, but eventually alert the user when the download did not work.

#6 - 07/19/2014 02:11 AM - Knédlseder Jirgen

- Target version deleted (2nd coding sprint)
